public class Pilha extends Lista {	
	// inicio = topo
	// fim = base
	
	public Pilha () {
    	super(); 
	}

	public boolean insere(No no) {
		if (getInicio() != null)  {
			No aux = getInicio();
			no.setProximo(aux);
			aux.setAnterior(no);
			setInicio(no);
			setElementos(getElementos()+1);
		} else {
			no.setAnterior(null);
			no.setProximo(null);
			setInicio(no);
			setFim(no);
			setElementos(getElementos()+1);
		}
		return true;
	}

	
	public No remove () {
		if (getInicio() != null && getElementos() > 1)  {
			No aux = getInicio();
			aux.getProximo().getAnterior().setAnterior(null);
			setInicio(aux.getProximo());
			setElementos(getElementos()-1);
			return aux;
		} else {
			if (getInicio() == getFim()) {
				No aux = getInicio();
				setInicio(null);
				setFim(null);
				return aux;
			} else
				return null;
		}
	}

	public String lista() {
		String conteudo = "Conteudo da Pilha: ";
		No aux = getInicio();
		if (aux != null) {
			do  {
				conteudo += aux;
				aux = aux.getProximo(); 
			} while (aux != null);
		} else {
			conteudo += "vazia!";
		}
		return conteudo;
	}
	
	public boolean estaVazia() {
		if (getElementos() == 0)
			return true;
		else
			return false;
	}
		
}